#target indesign
#targetengine "Catapult"
// BobsXmlLibrary.jsx


///
/// Xml Parser and Xml.Nodes
///
Xml = {};
Xml.Parser = {};
Xml.Parser.findNodeCount = 0;
Xml.Parser.inlineTags = new BobsLib.Hashtable();
Xml.Parser.inlineTags.putValue( "a", "true" );
Xml.Parser.inlineTags.putValue( "b", "true" );
Xml.Parser.inlineTags.putValue( "em", "true" );
Xml.Parser.inlineTags.putValue( "i", "true" );
Xml.Parser.inlineTags.putValue( "sup", "true" );
Xml.Parser.inlineTags.putValue( "s", "true" );
Xml.Parser.inlineTags.putValue( "strike", "true" );
Xml.Parser.inlineTags.putValue( "em", "true" );
Xml.Parser.inlineTags.putValue( "strong", "true" );
Xml.Parser.inlineTags.putValue( "sup", "true" );
Xml.Parser.inlineTags.putValue( "sub", "true" );
Xml.Parser.inlineTags.putValue( "ta", "true" );
Xml.Parser.inlineTags.putValue( "tt", "true" );
Xml.Parser.inlineTags.putValue( "tu", "true" );
Xml.Parser.inlineTags.putValue( "big", "true" );
Xml.Parser.inlineTags.putValue( "small", "true" );
Xml.Parser.inlineTags.putValue( "img", "true" );
Xml.Parser.inlineTags.putValue( "code", "true" );
Xml.Parser.inlineTags.putValue( "samp", "true" );
Xml.Parser.inlineTags.putValue( "kbd", "true" );
Xml.Parser.inlineTags.putValue( "var", "true" );
Xml.Parser.inlineTags.putValue( "cite", "true" );
Xml.Parser.inlineTags.putValue( "q", "true" );
Xml.Parser.inlineTags.putValue( "span", "true");

Xml.Parser.htmlTags = new BobsLib.Hashtable();
Xml.Parser.htmlTags.putValue( "a", "true" );
Xml.Parser.htmlTags.putValue( "b", "true" );
Xml.Parser.htmlTags.putValue( "em", "true" );
Xml.Parser.htmlTags.putValue( "i", "true" );
Xml.Parser.htmlTags.putValue( "sup", "true" );
Xml.Parser.htmlTags.putValue( "s", "true" );
Xml.Parser.htmlTags.putValue( "strike", "true" );
Xml.Parser.htmlTags.putValue( "em", "true" );
Xml.Parser.htmlTags.putValue( "strong", "true" );
Xml.Parser.htmlTags.putValue( "sup", "true" );
Xml.Parser.htmlTags.putValue( "sub", "true" );
Xml.Parser.htmlTags.putValue( "ta", "true" );
Xml.Parser.htmlTags.putValue( "tt", "true" );
Xml.Parser.htmlTags.putValue( "tu", "true" );
Xml.Parser.htmlTags.putValue( "big", "true" );
Xml.Parser.htmlTags.putValue( "small", "true" );
Xml.Parser.htmlTags.putValue( "img", "true" );
Xml.Parser.htmlTags.putValue( "code", "true" );
Xml.Parser.htmlTags.putValue( "samp", "true" );
Xml.Parser.htmlTags.putValue( "kbd", "true" );
Xml.Parser.htmlTags.putValue( "var", "true" );
Xml.Parser.htmlTags.putValue( "cite", "true" );
Xml.Parser.htmlTags.putValue( "q", "true" );
Xml.Parser.htmlTags.putValue( "span", "true");
Xml.Parser.htmlTags.putValue( "html", "true");
Xml.Parser.htmlTags.putValue( "head", "true");
Xml.Parser.htmlTags.putValue( "body", "true");
Xml.Parser.htmlTags.putValue( "div", "true");
Xml.Parser.htmlTags.putValue( "p", "true");
Xml.Parser.htmlTags.putValue( "ui", "true");
Xml.Parser.htmlTags.putValue( "ol", "true");
Xml.Parser.htmlTags.putValue( "di", "true");
Xml.Parser.htmlTags.putValue( "li", "true");
Xml.Parser.htmlTags.putValue( "dt", "true");
Xml.Parser.htmlTags.putValue( "dd", "true");
Xml.Parser.htmlTags.putValue( "tqble", "true");
Xml.Parser.htmlTags.putValue( "tr", "true");
Xml.Parser.htmlTags.putValue( "th", "true");
Xml.Parser.htmlTags.putValue( "td", "true");
Xml.Parser.htmlTags.putValue( "frame", "true");
Xml.Parser.htmlTags.putValue( "frameset", "true");
Xml.Parser.htmlTags.putValue( "br", "true" );

Xml.Parser._isInlineTag = function( st ) {
	return eval( Xml.Parser.inlineTags.getValue( st ) );
}
Xml.Parser._isHtmlTag = function( st ) {
	return eval( Xml.Parser.htmlTags.getValue( st ) );
}
Xml.Parser._isBlockTag = function( st ) {
	var isInline = Xml.Parser._isInlineTag( st );
	if ( !isInline ) {
		return true;
	}
	return false;
}

Xml.Parser.decodeURI = function( text ) {
	var txt = "";
	try {
		txt = File.decode( text );
	} catch ( e ) {
		txt = text;
	}
	return txt;
}
Xml.Parser._isUnaryTag = function( st ) {
	return ( st.indexOf( "/>" ) > -1 );
}
Xml.Parser._isCloseTag = function( st ) {
	return ( BobsLib.ltrim( st )[ 0 ] == "/" );
}
Xml.Parser._isBinaryTag = function( st ) {
	return ( st.indexOf( ">" ) > -1 );
}
Xml.Parser._extractTag = function( st ) {
	st = BobsLib.getCharsBefore( st, "/" );
	st = BobsLib.getCharsBefore( st, ">" );
	return BobsLib.getCharsBefore( st, " " );
}


Xml.Parser._extractAttributes = function( st, tag ) {
	st = BobsLib.trim( BobsLib.getCharsBefore( st, ">" ) );
	if ( BobsLib.endsWith( st, "/" ) ) {
		st = st.substr( 0, ( st.length - 1 ) );
	}
	return BobsLib.trim( BobsLib.getCharsAfter( st, tag ) );
}
Xml.Parser._extractContents = function( st ) {
	return BobsLib.getCharsAfter( st, ">" );
}
Xml.Parser._parseAttributes = function( node, st ) {
	while ( st.length > 0 ) {
		var aName = BobsLib.trim( BobsLib.getCharsBefore( st, "=" ) );
		st = BobsLib.ltrim( BobsLib.getCharsAfter( st, "=" ) );
		if ( BobsLib.startsWith( st, '"' ) ) {
			st = st.substr( 1 );
			var aValue = BobsLib.getCharsBefore( st, '"' );
			st = BobsLib.ltrim( BobsLib.getCharsAfter( st, '"' ) );
		} else {
			var aValue = BobsLib.getCharsBefore( st, " " );
			st = BobsLib.ltrim( BobsLib.getCharsAfter( st, " " ) );
		}
		node.addAttribute( aName, aValue );
		st = BobsLib.ltrim( st );
	}
}


Xml.Parser._parseXml = function( buf ) {
	if ( buf.length == 0 ) {
		return undefined;
	}
//	var ar = BobsLib.trim( buf ).split( "<" );
    buf = BobsLib.trimAllControlChars( buf );
	var tagArray = BobsLib.ltrim( buf ).split( "<" );

	var root = undefined;
	var i = 0;
	while ( BobsLib.trim( tagArray[ i ] ).length == 0 ) {
		i++
	}
	if ( !BobsLib.startsWith( tagArray[ i ].toLowerCase(), "?xml" ) ) {
		var start = i;
		var root = new Xml.Node("root");
	} else {
		var start = i + 1;
		var root = new Xml.Node( "Document" );
		var attributes = BobsLib.getCharsAfter(  tagArray[ i ], "?xml" );
		attributes = BobsLib.getCharsBefore( attributes, "?>" );
		Xml.Parser._parseAttributes( root, attributes );
		var content = BobsLib.getCharsAfter( tagArray[ i ], "?>" );
		root.addContent( BobsLib.trim( BobsLib.removeExtraSpaces( content ) ) );
	}
	root.rootNode = root;
	var tagStack = new BobsLib.Stack();
	tagStack.push( root );
	var node = root;
	var parentNode = root;

	for ( var i = start; i < tagArray.length; i++ ) {
		// prepares the next chunk of text to parse
		var chunk = BobsLib.replace( BobsLib.ltrim( tagArray[ i ] ), "\">", "\" >" );
//		chunk = BobsLib.replace( chunk, "\"/>", "\" />" );
		var prevNode = node;
		var tag = Xml.Parser._extractTag( chunk );

		var attributes = Xml.Parser._extractAttributes( chunk, tag );
		var content = Xml.Parser._extractContents( chunk );

		if ( Xml.Parser._isCloseTag( chunk ) ) {
			// reset to the upline hierarchy level
			if ( node.blockTag ) {
//				if ( !( content instanceof Xml.Node ) ) {
//					if ( content[ 0 ] == " " )  {
//						node.rightTrimLastContent( " " );
//					} else {
//						node.rightTrimLastContent();
//					}
//				} else {
						node.rightTrimLastContent();
//				}
			}
			node = tagStack.pop();
			parentNode = tagStack.peek();
			// since it's after a close, content here is part of the parent tag
			if ( parentNode ) {
				if ( Xml.Parser._isHtmlTag( parentNode.tag ) ) {
					content = BobsLib.removeExtraSpaces( content );
				}
				parentNode.addContent( content );
			}
		} else if ( Xml.Parser._isUnaryTag( chunk ) ) {
			var node = parentNode.addChildNode( tag );
			if ( Xml.Parser._isHtmlTag( parentNode.tag ) ) {
				content = BobsLib.removeExtraSpaces( content );
			}
			if ( Xml.Parser._isBlockTag( tag ) ) { // only to catch the <br/> case...
				content = BobsLib.ltrim( content );
				parentNode.rightTrimLastContent();
			}			
			parentNode.addContent( content );
			Xml.Parser._parseAttributes( node, attributes );
			node.isBinary = false;
		} else if ( Xml.Parser._isBinaryTag( chunk ) ) {
			if ( Xml.Parser._isHtmlTag( tag ) ) {
				content = BobsLib.removeExtraSpaces( content );
			}
			if ( Xml.Parser._isBlockTag( tag ) ) {
				content = BobsLib.ltrim( content );
				parentNode.rightTrimLastContent();
			}
			var node = parentNode.addChildNode( tag, content );
			Xml.Parser._parseAttributes( node, attributes );
			tagStack.push( node );
			parentNode = node;
			node.isBinary = true;
		} else { // it's just text, like at the start of the file. Everything else pretty much has to be in a tag of some sort.			
			if ( Xml.Parser._isHtmlTag( parentNode.tag ) ) {
				content = BobsLib.removeExtraSpaces( content );
			}
			if ( Xml.Parser._isBlockTag( tag ) ) {
				chunk = BobsLib.trim( chunk );
			}
			parentNode.addContent( BobsLib.removeExtraSpaces( chunk ) );
		}
		prevNode.next = node;
		node.prev = prevNode;
	}
	return root;
}
Xml.Parser.parseText = function( text ) {
	buffer = BobsLib.trim( text );
	if ( !BobsLib.startsWith( buffer, "<" ) ) {
		buffer = "<xmlLeadingText>" + buffer + "</xmlLeadingText>";
	}
	return Xml.Parser._parseXml( buffer );
}
Xml.Parser.parse = function( f ) {
	f = new File( f );
	f.open( "r" );
	var buffer = f.read();
	f.close();
	buffer = BobsLib.trim( buffer );
	if ( !BobsLib.startsWith( buffer, "<" ) ) {
		buffer = "<xmlLeadingText>" + buffer + "</xmlLeadingText>";
	}
	var root = Xml.Parser._parseXml( buffer );
//	var b = new Xml.Node.TextBuffer();
//	root.write( b );
	return root;
}
Xml.Parser.getAndParseFile = function() {
	var f = File.openDialog( "Select an Xml File" );
	if ( f ) {
		return Xml.Parser.parse( f );
	} else {
		return undefined;
	}
}
///
/// Xml.Node
///
Xml.ParseResults = new BobsLib.Hashtable();
Xml.addToParseResults = function( node ) {
	var ar = Xml.ParseResults.getValue( node.tag );
	if ( !ar ) {
		ar = new Array();
	}
	ar.push( node );
	Xml.ParseResults.putValue( node.tag, ar );
}
Xml.Node = function( tag, value, nParent ) {
	this.content = new Array();
	this.nodeChildren = new Array( 0 );
	this.attr = new BobsLib.Hashtable();
	this.tag = BobsLib.trim( tag );
	this.blockTag = Xml.Parser._isBlockTag( this.tag );
	if ( value ) {
		if ( value.length > 0 ) {
			this.value = value;
			this.content.push( value );
		}
	}
	this.parentNode = nParent;
	if ( nParent ) {
		this.rootNode = nParent.rootNode;
	} else {
		this.rootNode = undefined;
	}
	this.isBinary = undefined;
	this.prev = undefined;
	this.next = undefined;
}
Xml.Node.prototype.rightTrimLastContent = function( sp ) {
	if ( !sp ) {
		sp = "";
	}	
	for ( var i = ( this.content.length - 1 ); i >= 0; i-- ) {
		if ( !( this.content[ i ] instanceof Xml.Node ) ) {
			var c = BobsLib.rtrim( this.content[ i ] );
			if ( c.length > 0 ) {
				this.content[ i ] = c + sp;
				break;
			} else {
				this.content.splice( i, 1 );
			}
		}
	}
}

Xml.Node.prototype._VeriyXmlNode = function() {
	return true;
}
// content is different than nodeChildren - content is an array, it works like this - 
// content is a flow of content and nodeChildren -
// content[0] could be text, content[1] could be a node.
// so when you add childNodes, you are pushing to nodeChildren and to content
// when you add text, you are pushing to content only
Xml.Node.prototype.addContent = function( text ) {
	if ( text instanceof Xml.Node ) {
		this.nodeChildren.push( text );
		this.content.push( text );
	} else {
		if ( text.length > 0 ) {
			this.content.push( text );
		}
	}
}
Xml.Node.prototype.writeContents = function() {
	var buf = new BobsLib.StringBuffer();
	for ( var i in this.content ) {
		if ( this.content[ i ] instanceof Xml.Node ) {
			buf.append( this.content[ i ].write() );
		} else {
			buf.append( this.content[ i ] );
		}
	}
	return buf.toString();
}
Xml.Node.prototype.contentAsString = function() {
	var buffer = new BobsLib.StringBuffer();
	buffer = this._contentAsString( buffer );
	return buffer.toString();
}
Xml.Node.prototype._contentAsString = function( buffer ) {
	for ( var i in this.content ) {
		if ( this.content[ i ] instanceof Xml.Node ) {
			buffer = this.content[ i ]._contentAsString( buffer );
		} else {
			buffer.append( this.content[ i ] );
		}
	}
	return buffer;
}
Xml.Node.prototype.clone = function( parent ) {
	var answer = new Xml.Node( this.tag, undefined, parent );
	answer.attr = this.attr.clone();
	if ( parent ) {
		parent.addContent( answer );
	}
	for ( var i in this.content ) {
		if ( this.content[ i ] instanceof Xml.Node ) {
			answer.content[ i ] = this.content[ i ].clone( answer );
			this.nodeChildren.push( answer.content[ i ] );
		} else {
			if ( i == 0 ) {
				answer.value = this.content[ 0 ];
			}
			answer.content[ i ] = this.content[ i ];
		}
	}
	return answer;
}
Xml.Node.prototype.getValue = function() {
	return this.value;
}
Xml.Node.prototype.addChildNode = function( tag, value ) {
	var newNode = new Xml.Node( tag, value, this );
	this.addContent( newNode );
	return newNode;
}
Xml.Node.prototype.removeChildren = function() {
	this.nodeChildren = new Array();
	var ar = new Array();
	for ( var i in this.content ) {
		if ( !( this.content[ i ] instanceof Xml.Node ) ) {
			ar.push( this.content[ i ] );
		}
	}
	this.content = ar;
}
Xml.Node.prototype.remove = function() {
	if ( this.parentNode ) {
		for ( var i in this.parentNode.nodeChildren ) {
			if ( this.parentNode.nodeChildren[ i ] == this ) {
				var removed = this.parentNode.nodeChildren.splice( i, 1 );
			}
		}
	}
	return removed;
}
Xml.Node.prototype.addAttribute = function( name, value )  {
	this.attr.putValue( name, value );
}
Xml.Node.prototype.removeAttribute = function( name ) {
	this.attr.remove( name );
}	
Xml.Node.prototype.getAttributes = function()  {
	return this.attr;
}
Xml.Node.prototype.getAttribute = function( name ) {
	return this.attr.getValue( name );
}
Xml.Node.prototype.setAttributes = function( ht )  {
	this.attr = ht;
}
Xml.Node.prototype.writeAttributes = function() {
	var attrStr = '';
	for ( var i = 0; i < this.attr.keyList.length; i++ ) {
//		attrStr += ' ' + this.attr.keyList[ i ] + '="' + this.encode( this.attr.getValue( this.attr.keyList[ i ] ) ) + '"' ;
		attrStr += ' ' + this.attr.keyList[ i ] + '="' + this.attr.getValue( this.attr.keyList[ i ] ) + '"' ;
	}
	if ( attrStr.length > 0 ) {
		attrStr += " ";
	}
	return attrStr;
}
Xml.Node.prototype.encode = function( text ) {
	text = text.replace( /\&/g, "&amp;" );
	text = text.replace( />/g, "&gt;" );
	text = text.replace( /</g, "&lt;" );
	return text;
}
Xml.Node.prototype.write = function( aFile, spacer ) {
	if ( !aFile ) {
		aFile = Xml.Node.TextBuffer();
		var isText = true;
	}
	this._write( aFile, spacer );
	if ( isText ) {
		return aFile.toString();
	}
}Xml.Node.prototype.write = function( aFile, spacer ) {
	if ( !aFile ) {
		aFile = new Xml.Node.TextBuffer();
		var isText = true;
	}
	this._write( aFile, spacer );
	if ( isText ) {
		return aFile.toString();
	}
}
Xml.Node.prototype._write= function( aFile, spacer ) {
	if ( !spacer ) {
		spacer = "";
	}
	if ( this.tag.toLowerCase() == "document" )  {
		aFile.writeln( '<?xml ' + this.writeAttributes() + ' ?>' );
		for ( var i in this.content ) {
			if ( this.content[ i ] instanceof Xml.Node ) {
				this.content[ i ]._write( aFile, spacer );
			} else {
				aFile.write( this.encode( this.content[ i ] ) );
			}
		}
		return;
	} else {
		if ( !this.isBinary )  { // unary tag
			aFile.write( '<' + this.tag + this.writeAttributes() + '/>' );
		} else {
			var needToClose = true;
			if ( this.blockTag ) {
				spacer += "\t";
				aFile.writeln( "" ); // always put a new line before a block tag
				aFile.write( spacer  +  '<' + this.tag + this.writeAttributes() + '>' );
			} else {
				aFile.write( '<' + this.tag + this.writeAttributes() + '>' );
			}
			for ( var i in this.content ) {
				if ( this.content[ i ] instanceof Xml.Node ) {
					this.content[ i ]._write( aFile, spacer );
				} else {
					aFile.write( this.encode( this.content[ i ] ) );
				}
			}
			
		}
	}
// close off binary tags
	if ( this.isBinary )  { // binary tag
		if ( this.content.length > 0 ) {
			if ( this.blockTag ) { // has contents, is a block tag,
				aFile.writeln( "" );
				aFile.write( spacer + '</' + this.tag + '>' );
			} else {
				aFile.write( '</' + this.tag + '>' );
			}
		} else {
			if ( this.blockTag ) {
				aFile.write(  '</' + this.tag + '>' );
			} else {
				aFile.write( '</' + this.tag + '>' );
			}
		}
	}
}

Xml.Node.prototype.findNode = function( fTag, n, hierarchical, limit ) {
	if ( limit ) {
		limit = limit.toLowerCase();
	}
	if ( fTag ) {
		fTag = fTag.toLowerCase();
	}
	if ( !n ) {
		n = 0;
	} 
	if ( !hierarchical ) {
		hierarchical = true;
	}
	return this._findNode( fTag, Xml.Parser.findNodeCount, hierarchical, limit );
}
Xml.Node.prototype._findNode = function( fTag, n, hierarchical, limit ) {
	Xml.Parser.findNodeCount = n;
	for ( var i = 0; i < this.nodeChildren.length; i ++ ) {
		var s = this.nodeChildren[ i ].tag.toLowerCase();
		if ( limit && hierarchical ) {
			hierarchical = ( s != limit );
		}
		if ( fTag == s )  {
			if ( Xml.Parser.findNodeCount <= 0 ) {
				return this.nodeChildren[ i ];
			} else {
				Xml.Parser.findNodeCount -= 1;
			}
		} 
	//else if ( limit ) {
	//		if ( s == limit ) {
	//			return undefined;
	//		}
	//	}
		if ( hierarchical ) {
			var foundNode = this.nodeChildren[ i ]._findNode( fTag, Xml.Parser.findNodeCount, hierarchical, limit);
			if ( foundNode ) {
				return foundNode;
			}
		}
	}
	return undefined;
}
Xml.Node.prototype.findNodes = function( fTag, anArray, hierarchical, limit )  {
	if ( !anArray ) {
		anArray = new Array;
	}
	if ( fTag ) {
		fTag = fTag.toLowerCase();
	}
	if ( !hierarchical ) {
		hierarchical = true;
	}
	if ( limit ) {
		limit = limit.toLowerCase();
	}
	return this._findNodes( fTag, anArray, hierarchical, limit );
}
Xml.Node.prototype._findNodes = function( fTag, anArray, hierarchical, limit )  {
	theResult = anArray;
	for ( var i = 0; i < this.nodeChildren.length; i ++ ) {
		var s = this.nodeChildren[ i ].tag.toLowerCase();
		if ( limit && hierarchical ) {
			hierarchical = ( s != limit );
		}
		if ( fTag == s ) {
			theResult.push( this.nodeChildren[ i ] );
		}
//	else if ( limit ) {
//			if ( limit == s ) {
//				return theResult;
//			}
//		}
		if ( hierarchical ) {
			this.nodeChildren[ i ]._findNodes( fTag, theResult, hierarchical, limit );
		}
	}
	return theResult;
}
Xml.Node.prototype.toString = function() {
	var st = "[Xml.Node:" + this.tag + "]";
	if ( this.value ) {
		return ( st + " " + this.value.substr( 0, 10 ) );
	} else {
		return st;
	}
}

Xml.Node.TextBuffer = function( ) {
	this.buf = new BobsLib.StringBuffer();
}
Xml.Node.TextBuffer.prototype.write = function( text ) {
	this.buf.append( text );
}
Xml.Node.TextBuffer.prototype.writeln = function( text ) {
	this.buf.append( text + "\n" );
}
Xml.Node.TextBuffer.prototype.clear = function() {
	this.buf.clear();
}
Xml.Node.TextBuffer.prototype.toString = function() {
	return this.buf.toString();
}

/*
$.writeln( "BobsXmlLibrary.jsx loaded" );
var f = new File( Folder.myDocuments.absoluteURI + "/PrintPro CS3/Sample Data/PrintExportCLGWB_051907_1316_NoWH.xml" );
var f1 = new File( Folder.myDocuments.absoluteURI + "/PrintPro CS3/Sample Data/WriteBack.xml" );

if ( f.exists ) {
	var root = Xml.Parser.parse( f );
	f1.open( "w" );
	root.write( f1 );
	f1.close();
} else {
	$.writeln( "File No Go" );
}
*/


